package org.implab.gradle.containers.cli;

import java.io.Serializable;
import java.util.Optional;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;

public class ImageRef implements Serializable {

    private static final long serialVersionUID = 2023111901L;

    final String tag;

    final String id;

    @JsonCreator(mode = JsonCreator.Mode.PROPERTIES)
    public ImageRef(@JsonProperty("tag") String tag, @JsonProperty("id") String id) {
        this.id = id;
        this.tag = tag;
    }

    public String getId() {
        return id;
    }

    public ImageRef withId(String id) {
        return new ImageRef(tag, id);
    }

    public Optional<String> getTag() {
        return Optional.ofNullable(tag);
    }

    public ImageRef withTag(String tag) {
        return new ImageRef(tag, id);
    }
}
