package org.implab.gradle.containers.dsl;

import java.util.concurrent.Callable;
import org.gradle.api.provider.MapProperty;
import org.gradle.api.provider.Provider;
import org.gradle.api.provider.ProviderFactory;

public class MapPropertyEntry<K,V> {
    
    private final MapProperty<K,V> map;

    private final K key;

    private final ProviderFactory providerFactory;

    public MapPropertyEntry(MapProperty<K,V> map, K key, ProviderFactory providerFactory) {
        this.map = map;
        this.key = key;
        this.providerFactory = providerFactory;
    }

    void put(Callable<V> value) {
        map.put(key, providerFactory.provider(value));
    }

    void put(V value) {
        map.put(key, value);
    }

    void put(Provider<V> value) {
        map.put(key, value);
    }


}
