package org.implab.gradle.containers.dsl;

import java.util.ArrayList;

import org.gradle.api.provider.Property;
import org.gradle.api.provider.SetProperty;

public abstract class VolumeSpec {

    public abstract Property<String> getSource();

    public abstract Property<String> getTarget();

    public abstract SetProperty<String> getOptions();

    public void ro() {
        getOptions().add("ro");
    }

    public String resolveSpec() {
        var parts = new ArrayList<String>();

        if (getSource().isPresent())
            parts.add(getSource().get());

        parts.add(getTarget().get());

        if (getOptions().isPresent())
            parts.add(String.join(",", getOptions().get()));

        return String.join(":", parts);
    }
    
}
