package org.implab.gradle.containers.tasks;

import java.io.IOException;
import java.util.concurrent.ExecutionException;

import org.gradle.api.provider.Property;
import org.gradle.api.tasks.Internal;
import org.gradle.api.tasks.TaskAction;

public abstract class ComposeRm extends DockerCliTask implements ComposeTaskMixin {

    @Internal
    public abstract Property<Boolean> getRemoveVolumes();

    public ComposeRm() {
        applyComposeConvention();
        getRemoveVolumes().convention(true);
    }

    @TaskAction
    public void run() throws InterruptedException, IOException, ExecutionException {
        exec(docker().compose(this).rm(getRemoveVolumes().get()));
    }
}
