package org.implab.gradle.containers.tasks;

import java.io.IOException;
import java.util.concurrent.ExecutionException;

import org.gradle.api.tasks.Internal;
import org.gradle.api.tasks.TaskAction;

public abstract class ComposeUp extends DockerCliTask implements ComposeTaskMixin {

    private boolean detached = true;

    @Internal
    public boolean isDetached() {
        return detached;
    }

    public void setDetached(boolean value)  {
        detached = value;
    }

    public ComposeUp() {
        applyComposeConvention();
    }

    @TaskAction
    public void run() throws InterruptedException, IOException, ExecutionException {
        
        exec(docker().compose(this).up(isDetached()));
    }
}
