package org.implab.gradle.containers.tasks;

import java.io.IOException;
import java.util.ArrayList;
import java.util.concurrent.ExecutionException;

import org.gradle.api.tasks.TaskAction;

public abstract class ExecContainer extends BaseExecTask implements ContainerTaskMixin {

    public ExecContainer() {
        onlyIfReason("No container specified", self -> getContainerId().isPresent());
    }

    @TaskAction
    public void run() throws InterruptedException, IOException, ExecutionException {
        var params = new ArrayList<>(getOptions().get());

        if (isInteractive())
            params.add("--interactive");
        if (isDetached())
            params.add("--detach");
        if (getAllocateTty())
            params.add("--tty");

        exec(docker().containerExec(
                getContainerId().get(),
                params,
                getCommandLine().get()));
    }

}
